<template>
  <div class="comment-wrapper">
    <div class="container">
      <div class="comment-header">
        <h3>Comments</h3>
        <button
          v-if="loggedIn"
          class="comment-anchor"
          @click.prevent="() => $refs.formTextarea.focus()"
        >
          Оставить комментарий
        </button>
      </div>

      <div class="comment-list">
        <ul>
          <base-comment
            v-for="(comment, idx) in comments.results"
            :key="idx"
            v-bind="comment"
            @reply="setReply"
          />
        </ul>
      </div>

      <base-pagination :total-pages="comments.count_pages" />

      <div v-if="loggedIn" class="comment-form">
        <div class="comment-box">
          <base-avatar :src="user.avatar" class="author-avatar" />
          <div class="form-body">
            <div class="form-body-author d-flex align-items-center">
              <div class="author-name">{{ user.username }}</div>
              <template v-if="controls.reply.user_name">
                <i class="icon-arrow_long"></i>
                <div class="author-name author-name_reply" @click="resetReply">
                  {{ controls.reply.user_name }}
                </div>
              </template>
            </div>
            <form id="send-comment" @submit.prevent="createComment">
              <textarea
                ref="formTextarea"
                v-model="controls.text"
                name="comment"
                rows="3"
                placeholder="Написать текст..."
              ></textarea>
              <div
                v-show="controls.uploaded_images.length"
                class="comment-images"
              >
                <div
                  v-for="(image, idx) in controls.uploaded_images"
                  :key="image.lastModified"
                  class="comment-images__wrapper"
                >
                  <img :src="createUrl(image)" alt="Загруженное изображение" />
                  <button @click="() => removeImage(idx)">&#10005;</button>
                </div>
              </div>
              <base-input
                id="images"
                component="file"
                placeholder=""
                accept="image/jpeg,image/png,image/gif"
                multiple
                @upload="controls.uploaded_images.push(...$event)"
              />
            </form>
          </div>
        </div>
        <button
          type="submit"
          form="send-comment"
          :disabled="loading || !controls.text"
          class="btn btn-primary"
        >
          Отправить комментарий
        </button>
      </div>
    </div>
  </div>
</template>

<script>
import { mapState } from 'vuex'
const initialControls = () => ({
  text: '',
  uploaded_images: [],
  reply: {
    parent: null,
    user_name: null,
  },
})
export default {
  name: 'ProductComments',
  /**
   * @typedef Data
   * @property {ResponseComments} comments Список комментариев
   * @property {Object} controls Форма
   * @property {String} controls.text Текст комментария
   * @property {File[]} controls.uploaded_images Прикреплённые изображения
   * @property {Object} controls.reply Ответ на комментарий
   * @property {number?} controls.reply.parent Ответ на комментарий
   * @property {string?} controls.reply.user_name Ответ на комментарий
   */
  /** @type {Data} */
  data() {
    return {
      /** @type {ResponseComments} */
      comments: {
        count: 1,
        count_pages: 0,
        links: {
          next: null,
          previous: null,
        },
        results: [],
      },
      controls: initialControls(),
    }
  },
  fetchOnServer: false,
  /** @this Data */
  async fetch() {
    this.comments = await this.$store.dispatch('comments/fetch', {
      query: this.$route.query,
      id: this.showroomId,
    })
  },
  computed: {
    ...mapState({
      loading: (state) => state.loading,
      user: (state) => state.auth.user,
      loggedIn: (state) => state.auth.loggedIn,
    }),
    showroomId() {
      return this.$store.getters['sitemap/slugMap'].showroom[
        this.$route.params.slug
      ]
    },
  },
  watch: {
    '$route.query.page': '$fetch',
  },
  methods: {
    /** @this Data */
    createComment() {
      if (this.controls.text) {
        this.$store
          .dispatch('comments/createComment', {
            text: this.controls.text,
            showroom: this.showroomId,
            parent: this.controls.reply.parent,
            uploaded_images: this.controls.uploaded_images,
          })
          .then(() => {
            if (this.$route.query.page === `${this.comments.count_pages}`) {
              this.$fetch()
            } else {
              this.$router.push({ query: { page: this.comments.count_pages } })
            }
            this.controls = initialControls()
          })
      }
    },
    /**
     * @param {File} file
     * @return {string|null}
     */
    createUrl(file) {
      if (typeof file === 'object' && file !== null) {
        return URL.createObjectURL(file)
      }
      return null
    },
    /**
     * @param {number} idx
     */
    removeImage(idx) {
      this.controls.uploaded_images = this.controls.uploaded_images.filter(
        (_, imageIdx) => idx !== imageIdx
      )
    },
    /**
     * @param {Object} comment
     * @param {number} comment.id
     * @param {string} comment.user_name
     */
    setReply(comment) {
      this.controls.reply.parent = comment.id
      this.controls.reply.user_name = comment.user_name
    },
    resetReply() {
      this.controls.reply = {
        parent: null,
        user_name: null,
      }
    },
  },
}
</script>
